// $Id: Skat.java,v 1.21 2006/08/31 08:00:57 orts_mburo Exp $

// (c) Jan Schaefer, Michael Buro
// licensed under GPL2

package ggs.ggsa._skat;

import ggs.ggsa.main.Global;

import java.awt.event.*;
import javax.swing.*;
import ggs.shared.*;
import ggs.service.skat.*;

/**
 * A Skat service client for GGSA
 * 
 * @author Jan Sch&auml;fer <j@nschaefer.net>
 */

public class Skat extends StdServiceClient
{
  public void init(Sender sender, Options opt)
  {
    super.init(sender, opt);

    gameBP = new SkatGame();
    
    serviceMenu = new JMenu();
    JMenuItem newMenuItem = new JMenuItem("Create table");
    newMenuItem.addActionListener(new ActionListener()
    {
      public void actionPerformed(ActionEvent evt)
      {

      }
    });
    serviceMenu.add(newMenuItem);

    tabPanel = new SkatTabPanel(this);
  }

  public String getLogin() { return new String("/skat"); }

  public String getName() { return "Skat"; }

  public String getOptPrefix() { return "skat"; }

  public Game getGameBP() { return gameBP; }
  
  public void setDefaultOptions()
  {
    // TODO Auto-generated method stub

  }

  public void shutDown()
  {
    // TODO Auto-generated method stub

  }

  public void clickedOnUser(String user)
  {
  }

  public JPanel getTabPanel() { return tabPanel; }

  public JMenu getMenu() { return serviceMenu; }

  protected void sendCreateTable()
  {
    send("t " + getLogin() + " create game");
  }
  

  // Sender interface : how to send messages
  
  public void send(String msg)
  {
    Global.core.send_to_server(msg);
  }
  
  private JMenu  serviceMenu;
  private JPanel tabPanel;
  private Game   gameBP;
}
