/* $Id: GGS_Move.java,v 1.2 2006/08/24 09:12:45 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.boardgamesvc;

import java.util.*;
import ggs.ggsa.main.*;

public class GGS_Move
{
  protected String move;
  protected float eval;
  protected float time;

  public GGS_Move() { eval = 0; time = 0; }

  public void copyOf(GGS_Move x)
  {
    move = x.move;
    eval = x.eval;
    time = x.time;
  }

  public boolean equals(GGS_Move x)
  {
    if (x == null) return false;
    if (x == this) return true;
    return move.equals(x.move) && eval == x.eval && time == x.time;
  }

  public void set_move(String m) { move = m; }
  public String get_move()       { return move; }

  public void set_eval(float f) { eval = f; }
  public float get_eval()       { return eval; }

  public void set_time(float f) { time = f; }
  public float get_time()       { return time; }

  public String fromString(String arg)
  {
    eval = 0;
    time = 0;

    StringTokenizer st = new StringTokenizer(arg, "/", true);
    Vector<String> strings = new Vector<String>();
    boolean prev_delim = true;
    
    while (st.hasMoreTokens()) {
      String s = st.nextToken();
      if (s.equals("/")) {
	if (prev_delim) strings.addElement("");
      } else strings.addElement(s);
      prev_delim = s.equals("/");
    }

    while (strings.size() < 3) strings.addElement("");
    String s1 = (String)strings.elementAt(0);
    String s2 = (String)strings.elementAt(1);
    String s3 = (String)strings.elementAt(2);

    if (s1.equals("")) return "missing move";

    move = s1;
    
    // read eval

    if (!s2.equals("")) {
      try { eval = Float.valueOf(s2).floatValue(); }
      catch (NumberFormatException e) { return "illegal move eval"; }
    }

    // read time

    if (!s3.equals("")) {
      try { time = Float.valueOf(s3).floatValue(); }
      catch (NumberFormatException e) { return "illegal move eval"; }
    } 

    return null;
  }

  public String toString()
  {
    String s = move;
    final float min_val = 0.005f;
    
    if (Math.abs(eval) >= min_val || time >= min_val) {
      s += "/";
      Format f = new Format("%.2f");
      if (Math.abs(eval) >= min_val) s += f.form(eval);
      if (time >= min_val) s += "/" + f.form(time);
    }

    return s;
  }
}

