/* $Id: PlayerColor.java,v 1.1.1.1 2006/08/21 04:26:03 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.boardgamesvc;

import ggs.ggsa.main.*;


public class PlayerColor
{
  public static final int BLACK       = 0;
  public static final int WHITE       = 1;
  public static final int UNDEF       = 2;
  public static final int ALL         = 3;
  public static final int NONE        = 4;
  public static final int VERTICAL    = 5;
  public static final int HORIZONTAL  = 6;

  public static int opponent(int col) {
    if (col != BLACK && col != WHITE)
      Global.errmsg("opponent: illegal color");
    if (col == BLACK) return WHITE; else return BLACK;
  }

  public static String toString(int col) {
    switch (col) {
    case UNDEF: return "?";
    case BLACK: return "*";
    case WHITE: return "O";
    case ALL:   return "!";
    case NONE:  return "%";
    case VERTICAL: return "V";
    case HORIZONTAL: return "H";
    default: Global.errmsg("toString: illegal color");
    }
    return "!";
  }

  public static int fromString(String s) {
    if      (s.equals("*")) return BLACK;
    else if (s.equals("O")) return WHITE;
    else if (s.equals("?")) return UNDEF;
    else if (s.equals("!")) return ALL;
    else if (s.equals("%")) return NONE;
    else if (s.equals("V")) return VERTICAL;
    else if (s.equals("H")) return HORIZONTAL;
    else Global.errmsg("fromString: illegal color");
    return -1;
  }

}

