/* $Id: Request.java,v 1.1.1.1 2006/08/21 04:26:05 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.boardgamesvc;


public class Request implements Cloneable
{
  public String    game_id    = ".?";
  public String    stored_match_id = "";
  public char      mode       = '?';
  public String    game_type;
  public GameClock my_clock;
  public GameClock your_clock;
  public String    player     = "piglet09";
  public String    rating     = "2901";

  Request(String gt)
  {
    game_type  = gt;
    my_clock   = new GameClock();
    your_clock = new GameClock();    
  }

  public Request(Request x) { copyOf(x); }

  public Request createCopy()
  {
    return new Request(this);
  }
  
  public void copyOf(Request x)
  {
    game_id    = new String(x.game_id);
    stored_match_id = new String(x.stored_match_id);    
    mode       = x.mode;
    game_type  = x.game_type;
    my_clock   = x.my_clock.createCopy();
    your_clock = x.your_clock.createCopy();
    player     = new String(x.player);
    rating     = new String(x.rating);
  }

  boolean equals(Request req)
  {
    if (req == null) return false;
    if (req == this) return true;

    if (!game_type.equals(req.game_type))   return false;
    if (!my_clock.equals(req.my_clock))     return false;
    if (!your_clock.equals(req.your_clock)) return false;  
    if (!player.equals(req.player))         return false;
    return true;
  }

}

