/*

*/


package ggs.ggsa.main;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.util.Vector;
import java.util.Enumeration;
 
public class CheckBoxMenuItemGroup
{
  // the list of buttons participating in this group
  protected Vector<JCheckBoxMenuItem> group = new Vector<JCheckBoxMenuItem>();

  /**
   * The current choice.
   */
  JCheckBoxMenuItem selection = null;

  /**
   * Creates a new group
   */
  public CheckBoxMenuItemGroup() {}

  /**
   * Adds a button to the group.
   */ 
  public synchronized void add(JCheckBoxMenuItem cbmi)
  {
    if (cbmi == null) return;
    group.addElement(cbmi);

    if(selection == null && cbmi.getState()) {
      selection = cbmi;
    }
  }
 
  /**
   * Removes the button from the group.
   */ 
  public synchronized void remove(JCheckBoxMenuItem cbmi)
  {
    if (cbmi == null) return;
    group.removeElement(cbmi);
    if (cbmi == selection) selection = null;
  }

  /**
   * Return all the buttons that are participating in
   * this group.
   */
  public synchronized Enumeration getElements()
  {
    return group.elements();
  }

  /**
   * Return the selected button model.
   */
  public synchronized JCheckBoxMenuItem getSelection()
  {
    return selection;
  }

  /**
   * Sets the selected value for the button.
   */

  public synchronized void setSelected(JCheckBoxMenuItem m)
  {
    boolean f = m.getState();
    
    if (f && m != selection) {
      JCheckBoxMenuItem oldSelection = selection;
      selection = m;
      if(oldSelection != null) {
	oldSelection.setState(false);
      }
    }

    if (!f) {
      if (m == selection)
	selection.setState(true);  // back to false not allowed
    }
  }

}
