/* $Id: GGSEventThread.java,v 1.6 2006/08/28 06:57:30 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import javax.swing.*;
import sun.audio.*;
import ggs.shared.*;

public class GGSEventThread extends Thread
{
  final static String EOM1 = "READY";
  final static String EOM2 = "ALERT";
  public  EventFactory ef = null;
  private SocketComm   sc = null;
  private boolean active = false;
  private Vector<String> strings = null;
	    
  class GGS_Runnable implements Runnable 
  {
    Vector<String> strings = new Vector<String>();

    GGS_Runnable(Vector<String> strs) {
      strings.addAll(strs);
    }
    
    public void run() {
      ef.send(strings);
    }
  }
  
  
  public GGSEventThread(String id, SocketComm sc)
  {
    ef = new EventFactory(id);
    this.sc = sc;
  }

  public void run()
  {
    try {

      while (true) {

	// Global.dbgmsg("reading ...");
      
	String line = sc.read_line();

	if (line == null)
	  throw new IOException("read_line = null");

	// Global.dbgmsg("line read: <" + line + ">" + line.length());

	if (!active && line.equals(""))
	  continue; // skip empty prefix lines

	if (!active) {
	  active = true;
	  strings = new Vector<String>();
	}


	strings.add(line);

	if (line.equals(EOM1) || line.equals(EOM2)) {

	  // Global.dbgmsg("message complete: send");

	  // for (int i=0; i < strings.size(); i++) {
	  //   Global.dbgmsg("### " + i + ": " + (String)strings.elementAt(i));

	  if (strings.size() > 1) {  // ignore empty messages
	  
	    // message complete: distribute message

	    if (!strings.get(0).startsWith(":")) {

	      // message from client/service -> delete leading '|'s
	
	      for (int i=1; i < strings.size(); i++) {
		String s = strings.get(i);
		if (s.startsWith("|")) {
		  strings.set(i, s.substring(1));
		}
	      }
	    }

	    // remove last line (EOM)

	    strings.remove(strings.size()-1);

	    if (false) {
	      for (int i=0; i < strings.size(); i++) {
		Global.dbgmsg(">>> " + i + ": " + strings.get(i));
	      }
	    }

	    // delete \a and ring bell if one occurs somewhere

	    boolean bell = false;
	    for (int i=0; i < strings.size(); i++) {
	      String s = strings.elementAt(i);
	      if (s.indexOf('\u0007') >= 0) {
		bell = true;
		strings.setElementAt(s.replaceAll("\u0007", ""), i);
	      }
	    }

	    if (bell) {

	      // play sound
	      
	      try {
		
		InputStream ins = GGSEventThread.class.getResourceAsStream(Global.options.getString("bf"));
		if (ins == null) throw new java.io.IOException();
		AudioStream as = new AudioStream(ins);
		AudioPlayer.player.start(as);
	      }
	      catch (java.io.IOException e) {
		Global.dbgmsg("WARNING: could not open audio stream");
	      }
	      
	      // Toolkit.getDefaultToolkit().beep();
	    }
	      
	    SwingUtilities.invokeLater(new GGS_Runnable(strings));
	  }

	  active = false;
	}
      }
    }
    catch (IOException e) {
      if (!Global.in_shut_down)
	Global.shut_down();
    }
  }

}

