/* $Id: Global.java,v 1.6 2006/08/29 09:10:41 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.awt.*;
import java.applet.*;
import java.util.*;
import java.io.*;

import ggs.shared.*;


public class Global 
{
  public static final String VERSION = "2.0:2006-08-17";
  public static boolean in_shut_down = false;

  public static Options          options = null;

  // console
  public static Frame              frame = null;
  public static LimitedTextArea dbg_text = null;

  public static Thread        core_thread = null;
  public static Core                 core = null;
  public static SocketComm             sc = null;

  public static GGSEventThread        ggs = null;
  public static MainWindow    main_window = null;

  public static String    last_sent_line = null;
  public static boolean          DBG_GGF = false;

  public static boolean from_main = false;

  public static void init(boolean fm, Geometry geom)
  {
    from_main = fm;
    options = new Options();

    if (!from_main) {
      dbg_text = new LimitedTextArea("",80,20,TextArea.SCROLLBARS_VERTICAL_ONLY);
      dbg_text.setEditable(false);
      dbg_text.setFont(new Font("monospaced", Font.PLAIN, 12));
      dbg_text.setLimit(40000*80);

      frame = new Frame();
      frame.setTitle("Console");
      frame.setSize(geom.get_w(), geom.get_h());
      frame.setLocation(geom.get_x(), geom.get_y());
      frame.setLayout(new BorderLayout());
      frame.add(dbg_text, BorderLayout.CENTER);
      frame.setVisible(true);
    }
  }

  public static void dbgmsg(String msg)
  {
    if (dbg_text != null) {
      dbg_text.append('\n' + msg); dbg_text.setCaretPosition(Integer.MAX_VALUE);
    }
    System.out.println(msg);
  }

  public static void errmsg(String s)
  {
    Global.dbgmsg("*** " + s);
    shut_down();
  }
  
  public static void shut_down()
  {
    in_shut_down = true;
    options = null;

    Global.dbgmsg("... ggs_ef");
    if (ggs != null) { ggs = null; }

    Global.dbgmsg("... connection");
    if (sc != null) { sc.close(); sc = null; }

    Global.dbgmsg("... services:");    
    if (core != null) { core.shut_down(); core = null; }

    Global.dbgmsg("... main window");
    if (main_window != null) { main_window.shut_down(); main_window = null; }

    Global.dbgmsg("... core");
    if (core_thread != null) { core_thread = null; core = null; }

    if (frame != null) { frame.dispose(); frame = null; }
    dbg_text = null;
    
    if (from_main)
      System.exit(0);
  }

  /** sleep n milliseconds */
  public static void sleep(int n) 
  {
    try { Thread.currentThread().sleep(n); }
    catch(InterruptedException e) {;}
  }
}
