/* $Id: MyList.java,v 1.2 2006/08/28 06:57:30 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.awt.*;
import java.awt.event.*;
import ggs.shared.*;

// returns predefined preferred width and generates SLOW,FAST
// double-click events


public class MyList extends List
{
  public static final String SELECTED_ID    = "SELECTED";  
  public static final String SLOW_DOUBLE_ID = "SLOW_DOUBLE";
  public static final String FAST_DOUBLE_ID = "FAST_DOUBLE";  
  
  protected int pref_width = 50;
  protected String id;
  protected EventHandler handler;
  protected int last_item_index = -1;

  MyList(int pref_width, String id, EventHandler handler) {
    this.id = id;
    this.pref_width = pref_width;
    this.handler = handler;
    enableEvents(-1);
  }
  
  // return pref_width if > 0
  
  public Dimension getPreferredSize() {

    Dimension d = super.getPreferredSize();
    if (pref_width > 0) return new Dimension(pref_width, d.height);
    return d;
  }

  protected synchronized void processEvent(AWTEvent evt) {

//     if (evt instanceof MouseEvent) {
//       Global.dbgmsg("click#= " + ((MouseEvent)evt).getClickCount());
//     }
    
    if (evt instanceof ItemEvent) {

      int sel = getSelectedIndex();

      handler.handle_event(new EventMsg(id, SELECTED_ID, ""+sel));

      if (false) {
	if (sel == last_item_index) {
	  last_item_index = -1;
	  handler.handle_event(new EventMsg(id, SLOW_DOUBLE_ID, ""+sel));
	} else {
	  last_item_index = sel;
	}
      }
      
    } else if (evt instanceof ActionEvent) {

      last_item_index = -1;
      handler.handle_event(new EventMsg(id, FAST_DOUBLE_ID, ""+getSelectedIndex()));
    }
    
    super.processEvent(evt);
  }
  
}
