/* $Id: Service.java,v 1.3 2006/08/28 06:57:30 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import javax.swing.*;
import ggs.shared.*;

public abstract class Service implements EventHandler
{
  /** initialize */
  abstract public void init();

  /** service arrived */
  abstract public void arrived();

  /** service departed */
  abstract public void departed();

  /** service menu */
  abstract public JMenu get_menu();

  /** service tab panel */
  abstract public JPanel get_tab_panel();

  /** clean up */
  abstract public void shut_down();

  /** @return true if service is connected to GGS */
  abstract public boolean connected();

  /** @return service ids */
  abstract public String get_login(); //  /os
  abstract public String get_name();  //  Othello

  /** user was selected in main window */
  abstract public void clicked_on_user(String who);

  /** append service options to Global.options */
  abstract public void set_default_options();
}
