/* $Id: StringStream.java,v 1.1.1.1 2006/08/21 04:26:02 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

public class StringStream
{
  final int EOS = -1; 
  String s;
  int    l;
  int    index;
  boolean ok_;
  
  public StringStream(String s)
  {
    this.s = s;
    l = s.length();
    index = 0;
    ok_ = true;
  }

  public char get()
  {
    if (!ok() || eos()) {
      ok_ = false;
      return '@';
    }
    return s.charAt(index++);
  }

  public char get_skip_ws()
  {
    char c;
    
    do {
      c = get();
      if (!ok()) return c;
    } while (Character.isWhitespace(c));

    return c;
  }

  public int get_int_skip_ws()
  {
    char c = get_skip_ws();
    if (!ok()) return 0;
    rewind(1);
    return get_int();
  }

  public String get_string()
  {
    char c = get_skip_ws();
    if (!ok()) return null;
      
    StringBuffer s = new StringBuffer();
    s.append(c);

    while (ok() && !eos()) {
      c = get();
      if (Character.isWhitespace(c)) { rewind(1); break; }
      s.append(c);
    }

    return s.toString();
  }
  
  public int get_int()
  {
    String t = "";
    int r;

    while (ok() && !eos()) {
      char c = get();
      if (!Character.isDigit(c)) {
	rewind(1);
	break;
      }
      t += "" + c;
    };

    try { r = Integer.parseInt(t); }
    catch (NumberFormatException e) { ok_ = false; r = 0; }
    return r;
  }
  
  public boolean ok()
  {
    return ok_;
  }

  public boolean eos()
  {
    return index >= l;
  }
  
  public void rewind(int d)
  {
    if (!ok()) return;
    index -= d;
    if (index < 0) index = 0;
    else if (index > l) index = l;
  }
  
}
