/* $Id: VertiLayoutConstraints.java,v 1.1.1.1 2006/08/21 04:26:02 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.ggsa.main;

import java.lang.Error;
import java.awt.*;
import java.awt.event.*;
import java.util.*;
 
public class VertiLayoutConstraints 
{
  public final static int ADJ = 0x10000;
  public final static int FIX = 0;      // default

  public int align;
  public int glue_weight;

  // ADJ weight = align & 0xffff

  public VertiLayoutConstraints() { this(0, 0); }

  public VertiLayoutConstraints(int align) { this(align, 0); }

  public VertiLayoutConstraints(int align, int glue_weight)
  {
    this.align = align;
    this.glue_weight = glue_weight;
  }

  public Object clone() throws CloneNotSupportedException 
  {
    return new VertiLayoutConstraints(align, glue_weight);
  }

  public boolean is_ADJ() { return (align & ADJ) != 0; }
  public boolean is_FIX() { return !is_ADJ(); }

  public int get_glue_weight() { return glue_weight; }

  public int get_ADJ_weight() { 
    if (!is_ADJ()) throw new Error("no weight for FIX components");
    int w = align & ~ADJ;
    if (w == 0) w = 1;
    return w;
  }

}
