/**
 $Id: ServerEventFactory.java,v 1.2 2006/08/28 06:57:30 orts_mburo Exp $
 $Source: /usr/bodo1/cvs/cvssoftware/ggs/src/ggs/service/common/ServerEventFactory.java,v $

 Reads and tokenizes messages from server, calls handler

 (c) Michael Buro, licensed under GPL2   
 */

package ggs.service.common;

import java.io.*;
import java.util.*;
import ggs.shared.*;

public class ServerEventFactory extends Thread
{
  final static String ID_SERVER = "server";
  final static String EOM1 = "READY";
  final static String EOM2 = "ALERT";
  public EventFactory ef = null;
  private SocketComm sc = null;
  private boolean active = false;
  private Vector<String> strings = null;

  public ServerEventFactory(SocketComm sc)
  {
    ef = new EventFactory(ID_SERVER);
    this.sc = sc;
  }

  public void run()
  {
    try {
      while (true) {

	// Global.msg("reading ...");

	String line = sc.read_line();

	if (line == null)
	  throw new IOException("read_line = null");

	// Global.msg("line read: <" + line + ">" + line.length());

	if (!active && line.equals(""))
	  continue; // skip empty prefix lines

	if (!active) {
	  active = true;
	  strings = new Vector<String>();
	}

	strings.addElement(line);

	if (line.equals(EOM1) || line.equals(EOM2)) {
	  // Global.dbgmsg("message complete: send");

	  // for (int i=0; i < strings.size(); i++) {
	  // Global.dbgmsg("### " + i + ": " +
	  // (String)strings.elementAt(i));

	  if (strings.size() > 1)
	    {
	      // ignore empty messages
	      // message complete: distribute message

	      if (!((String) strings.elementAt(0)).startsWith(":")) {
		// message from client/service -> delete leading // '|'s
		for (int i = 1; i < strings.size(); i++) {
		  String s = (String) strings.elementAt(i); 
		  if (s.startsWith("|")) {
		    strings.setElementAt(s.substring(1), i);
		  }
		}
	      }

	      // remove last line (EOM)
	      strings.removeElementAt(strings.size() - 1);
	      if (false) { 
		for (int i = 0; i < strings.size(); i++) {
		  Global.msg(">>> " + i + ": " + (String) strings.elementAt(i));
		}
	      }

	      // delete \a and ring bell if one occurs somewhere
	      boolean bell = false;
	      for (int i = 0; i < strings.size(); i++) {
		String s = (String) strings.elementAt(i);
		if (s.indexOf('\u0007') >= 0) {
		  bell = true;
		  // delete bell characters
		  s = s.replaceAll(Character.toString('\u0007'), "");
		}
	      }

	      if (bell) { 
		//Toolkit.getDefaultToolkit().beep();
	      }
						
	      ef.send(strings);
	    }
	  active = false;
	}
      }
    }

    catch (IOException e) {
      if (!Global.in_shut_down)
	Global.shut_down(10);
    }
  }
}
