/**
   $Id: Match.java,v 1.7 2006/09/04 03:40:42 orts_mburo Exp $
   $Source: /usr/bodo1/cvs/cvssoftware/ggs/src/ggs/shared/Match.java,v $
   
   Abstract Game Base Class

   (c) Michael Buro, licensed under GPL2
*/

package ggs.shared;

import java.util.*;

public abstract class Match
{
  /** initialize match
      @return null iff match_type OK, also return messages to players and viewers
      @return also return min/max number of players
  */
  public abstract boolean init(String match_type, int[] player_nums);

  /** 
      Start match
      @return TRUE iff match type mt OK
   */
  
  public abstract void start(int player_num, Random gen);

  /** execute player cmd given as string
   * @param player who moves
   * @param cmd to be executed
   * @param inClient true iff executed in client
   * @return null if OK, error message otherwise
   */
  public abstract String exec(int player, String cmd, boolean inClient);

  /**
   * @param perspective
   * @return move view
   */  
  public abstract String lastMoveView(int perspective);
  
  /**
   * @return current match view for perspective
   */  
  public abstract String view(int perspective);

  /** @return type of match */
  public abstract String getMatchType();
}
