/**
   $Id: SReader.java,v 1.2 2006/08/31 18:35:14 orts_mburo Exp $
   $Source: /usr/bodo1/cvs/cvssoftware/ggs/src/ggs/shared/SReader.java,v $

   Miscellanous functions

   (c) Michael Buro, licensed under GPL2      
*/

package ggs.shared;

import java.io.*;

public class SReader extends StringReader
{
  public SReader(String s) { super(s); }
  
  public String nextWord()
  {
    // return previous string if present
    
    if (prev != null) {
      // use previous word
      String p = prev;
      prev = null;
      return p;
    }
    
    // skip space

    int c;

    try {
      do {
	c = read();
      } while (c == ' ');

      if (c < 0)
	return null;

      // read word

      StringBuffer sb = new StringBuffer();

      while (c >= 0 && c != ' ') {
	sb.append((char)c);
	c = read();
      }
 
      return sb.toString();
    }

    catch (IOException e) {
      return null; // should not happen
    } 
  }

  /** reread string */
  public void pushBack(String s)
  {
    prev = s;
  }

  /** return remainder of stream */
  public String rest()
  {
    StringBuffer sb = new StringBuffer();
    int c;

    try {
      for (;;) {
	c = read();
	if (c < 0) break;
	sb.append(c);
      }
    }
    catch (IOException e) {
      return null; // should not happen
    } 

    return sb.toString();
  }

  String prev = null;
}
