/* $Id: ServiceClient.java,v 1.3 2006/08/31 06:26:18 orts_mburo Exp $
   
   (c) Michael Buro, licensed under the GPL2
*/

package ggs.shared;

import java.util.*;
import javax.swing.*;
import ggs.shared.*;
  
abstract public class ServiceClient extends Observable implements EventHandler,Sender
{
  /** initialize */
  public void init(Sender sender, Options opt)
  {
    this.options = opt;
    this.sender = sender; // for sending messages
  }

  /*
   * service arrived
   * derived classes need to call super.arrived()!  
  */
  public void arrived()
  {
    connected = true;
  }

  /* service departed
   * derived classes need to call super.departed()!
   */

  public void departed()
  {
    connected = false;
  }

  /** clean up */
  abstract public void shutDown();

  /** @return true if service is connected to GGS */
  public boolean getConnected() { return connected; }

  /** @return service ids */
  abstract public String getLogin(); //  /os
  abstract public String getName();  //  Othello

  public Options getOptions() { return options; }
  

  // gfx part

  /** service menu */
  abstract public JMenu getMenu();

  /** service tab panel */
  abstract public JPanel getTabPanel();

  /** user was selected in main window */
  abstract public void clickedOnUser(String who);

  /** append service options to Global.options */
  abstract public void setDefaultOptions();

  // data

  Sender sender;
  Options options;
  boolean connected = false;
}
